#ifndef _threadcontroller_
#define _threadcontroller_

#include "ilogger.h"
#include "pthreadwrapper/thread.h"
#include "pthreadwrapper/singleton.h"

class ThreadController:public PThread::Singleton<ThreadController>,public ILogger
{
public:
	ThreadController():m_freenetthread(NULL),m_httpthread(NULL),m_nntpthread(NULL)		{}
	~ThreadController();

	void StartThreads();
	void ShutdownThreads();
	void RestartThreads();

	void StartFreenetThread();
	void StartHTTPThread();
	void StartNNTPThread();

	void ShutdownFreenetThread();
	void ShutdownHTTPThread();
	void ShutdownNNTPThread();

private:
	void ReadConfig();

	bool m_startfreenet;
	bool m_starthttp;
	bool m_startnntp;

	PThread::Thread *m_freenetthread;
	PThread::Thread *m_httpthread;
	PThread::Thread *m_nntpthread;

};

#endif	// _threadcontroller_
